Program demo;

{$MODE objfpc}{$H+}

Uses
{$IFDEF UNIX}
  cthreads,
{$ENDIF}
{$IFDEF HASAMIGA}
  athreads,
{$ENDIF}
  Interfaces, // this includes the LCL widgetset
{$IFDEF LINUX}
  BaseUnix,
{$ENDIF}
  Forms, unit1
  { you can add units after this };

{$R *.res}


{$IFDEF LINUX}

Procedure DoKill(Signal: CInt); cdecl;
Begin
  If Signal = SIGTERM Then Begin
    writeln('Going down through sigkill..');
    form1.Close;
  End;
End;

Procedure InstallSigHandler;
Var
  Action: PSigActionRec;
Begin
  New(Action);
  Action^.sa_handler := SigActionHandler(@DoKill);
  FillChar(Action^.sa_mask, SizeOf(Action^.sa_mask), #0);
  Action^.sa_flags := 0;
  Action^.sa_restorer := Nil;
  If FPSigaction(SIGTERM, Action, Nil) <> 0 Then Begin
    WriteLn('Error: ', fpgeterrno);
    Halt(1);
  End;
  Dispose(Action);
End;
{$ENDIF}

Begin
{$IFDEF LINUX}
  InstallSigHandler;
{$ENDIF}
  RequireDerivedFormResource := True;
  Application.Scaled := True;
  Application.Initialize;
  Application.CreateForm(TForm1, Form1);
  Application.Run;
End.

